简单几何(半平面交+二分) LA 3890 Most Distant Point from the Sea

题目传送门

题意:凸多边形的小岛在海里,问岛上的点到海最远的距离。

分析:训练指南P279,二分答案,然后整个多边形往内部收缩,如果半平面交非空,那么这些点构成半平面,存在满足的点。

/************************************************
* Author        :Running_Time
* Created Time  :2015/11/10 星期二 14:16:17
* File Name     :LA_3890.cpp
 ************************************************/

#include <bits/stdc++.h>
using namespace std;

#define lson l, mid, rt << 1
#define rson mid + 1, r, rt << 1 | 1
typedef long long ll;
const int N = 1e5 + 10;
const int INF = 0x3f3f3f3f;
const int MOD = 1e9 + 7;
const double EPS = 1e-10;
const double PI = acos (-1.0);
int dcmp(double x)  {       //三态函数,减少精度问题
    if (fabs (x) < EPS) return 0;
    else    return x < 0 ? -1 : 1;
}
struct Point    {       //点的定义
    double x, y;
    Point () {}
    Point (double x, double y) : x (x), y (y) {}
    Point operator + (const Point &r) const {       //向量加法
        return Point (x + r.x, y + r.y);
    }
    Point operator - (const Point &r) const {       //向量减法
        return Point (x - r.x, y - r.y);
    }
    Point operator * (double p) const {       //向量乘以标量
        return Point (x * p, y * p);
    }
    Point operator / (double p) const {       //向量除以标量
        return Point (x / p, y / p);
    }
    bool operator < (const Point &r) const {       //点的坐标排序
        return x < r.x || (x == r.x && y < r.y);
    }
    bool operator == (const Point &r) const {       //判断同一个点
        return dcmp (x - r.x) == 0 && dcmp (y - r.y) == 0;
    }
};
typedef Point Vector;       //向量的定义
Point read_point(void)   {      //点的读入
    double x, y;    scanf ("%lf%lf", &x, &y);
    return Point (x, y);
}
double dot(Vector A, Vector B)  {       //向量点积
    return A.x * B.x + A.y * B.y;
}
double cross(Vector A, Vector B)    {       //向量叉积
    return A.x * B.y - A.y * B.x;
}
double length(Vector A) {       //向量长度,点积
    return sqrt (dot (A, A));
}
double polar_angle(Vector A)  {     //向量极角
    return atan2 (A.y, A.x);
}
Vector nomal(Vector A)  {       //向量的单位法向量
    double len = length (A);
    return Vector (-A.y / len, A.x / len);
}
struct Line {
    Point p;
    Vector v;
    double ang;
    Line () {}
    Line (const Point &p, const Vector &v) : p (p), v (v)   {
        ang = polar_angle (v);
    }
    bool operator < (const Line &r) const {
        return ang < r.ang;
    }
    Point point(double a)   {
        return p + v * a;
    }
};

bool point_on_left(Point p, Line L) {
    return cross (L.v, p - L.p) > 0;
}
Point line_line_inter(Point p, Vector V, Point q, Vector W)    {        //两直线交点,参数方程
    Vector U = p - q;
    double t = cross (W, U) / cross (V, W);
    return p + V * t;
}

vector<Point> half_plane_inter(vector<Line> L)    {
    sort (L.begin (), L.end ());
    int first, last, n = L.size ();
    Point *p = new Point[n];
    Line *q = new Line[n];
    q[first=last=0] = L[0];
    for (int i=1; i<n; ++i) {
        while (first < last && !point_on_left (p[last-1], L[i]))    last--;
        while (first < last && !point_on_left (p[first], L[i]))  first++;
        q[++last] = L[i];
        if (dcmp (cross (q[last].v, q[last-1].v)) == 0) {
            last--;
            if (point_on_left (L[i].p, q[last]))    q[last] = L[i];
        }
        if (first < last)   p[last-1] = line_line_inter (q[last-1].p, q[last-1].v, q[last].p, q[last].v);
    }
    while (first < last && !point_on_left (p[last-1], q[first]))    last--;
    vector<Point> ps;
    if (last - first <= 1)  return ps;
    p[last] = line_line_inter (q[last].p, q[last].v, q[first].p, q[first].v);
    for (int i=first; i<=last; ++i) ps.push_back (p[i]);
    return ps;
}

Point ps[110];
Vector V[110], V2[110];

int main(void)    {
    int n;
    while (scanf ("%d", &n) == 1)   {
        if (!n) break;
        for (int i=0; i<n; ++i) ps[i] = read_point ();
        for (int i=0; i<n; ++i) {
            V[i] = ps[(i+1)%n] - ps[i];
            V2[i] = nomal (V[i]);
        }
        double l = 0, r = 20000;
        while (r - l > EPS)    {
            double mid = l + (r - l) / 2;
            vector<Line> L;
            for (int i=0; i<n; ++i) {
                L.push_back (Line (ps[i] + V2[i] * mid, V[i]));
            }
            vector<Point> qs = half_plane_inter (L);
            int sz = qs.size ();
            if (sz == 0)    r = mid;
            else    l = mid;
        }
        printf ("%.6f\n", l);
    }

   //cout << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";

    return 0;
}

  

时间: 2025-01-01 18:59:00

简单几何(半平面交+二分) LA 3890 Most Distant Point from the Sea的相关文章

poj 3525 Most Distant Point from the Sea 半平面交 + 二分

题目来源: http://poj.org/problem?id=3525 分析: 题意:给定一个凸多边形,求多边形中距离边界最远的点到边界的距离. 思路 : 每次将凸多边形每条边往里平移d,判断是否存在核:二分d即可. 多边形边上的点(x , y)往里平移d 后的 坐标: s , e  为向量的 起点和终点, len 为起点和终点的距离, h 为平移的距离 x' = x + dx y' = y + dy dx = ( s.y - e.y ) / len * h ,( 原理 是 利用 三角形的相似

UVA 3890 Most Distant Point from the Sea(二分法+半平面交)

题目链接:http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=11358 [思路] 二分法+半平面交 二分与海边的的距离,由法向量可以得到平移后的各边,半平面交在特定精度判断是否有交集. [代码] 1 #include<cmath> 2 #include<cstdio> 3 #include<cstring> 4 #include<algorithm> 5 using namespace s

HDU 6617 Enveloping Convex(凸包+半平面交+二分)

首先对于这m个点维护出一个凸包M,那么问题就变成了判断凸包P进行放大缩小能不能包含凸包M.(凸包P可以进行中心对称变换再进行放大缩小,见题意) 如何判断合适的相似比呢,我们可以用二分去放大缩小凸包P的坐标,得到最小的相似比. 接下来就是如何判断是否包含.我们需要对凸包P上的每一条向量,在凸包M上找到这么一个点,使得这个点左侧的所有凸包M上的点都在向量的左侧,那么我们可以直接同时逆时针枚举,用一个变量维护凸包M上的点,因为是同逆时针,凸包M上的点至少有一个只会被遍历一次,那么复杂度可以证明为On,

uvalive 3890 Most Distant Point from the Sea

题意:求一个凸多边形中一点到边的最大距离. 思路:转换成在多边形内部,到每边距离为d的直线所围成的内多边形是否存在.也就是,二分距离+半平面交. 1 #include<cstdio> 2 #include<cmath> 3 #include<cstring> 4 #include<algorithm> 5 #include<iostream> 6 #include<memory.h> 7 #include<cstdlib>

POJ 3525 半平面交+二分

二分所能形成圆的最大距离,然后将每一条边都向内推进这个距离,最后所有边组合在一起判断时候存在内部点 1 #include <cstdio> 2 #include <cstring> 3 #include <iostream> 4 #include <algorithm> 5 #include <cmath> 6 7 using namespace std; 8 #define N 105 9 #define ll long long 10 #de

LA 3890 (半平面交) Most Distant Point from the Sea

题意: 给出一个凸n边形,求多边形内部一点使得该点到边的最小距离最大. 分析: 最小值最大可以用二分. 多边形每条边的左边是一个半平面,将这n个半平面向左移动距离x,则将这个凸多边形缩小了.如果这n个半平面交非空,则存在这样距离为x的点,反之则不存在. 半平面交的代码还没有完全理解. 和凸包类似,先对这些半平面进行极角排序.每次新加入的平面可能让队尾的平面变得“无用”,从而需要删除.由于极角序是环形的,所以也可能让队首元素变得“无用”.所以用双端队列来维护. 1 //#define LOCAL

POJ3525-Most Distant Point from the Sea(二分+半平面交)

Most Distant Point from the Sea Time Limit: 5000MS   Memory Limit: 65536K Total Submissions: 3955   Accepted: 1847   Special Judge Description The main land of Japan called Honshu is an island surrounded by the sea. In such an island, it is natural t

半平面交算法及简单应用

半平面:一条直线把二维平面分成两个平面. 半平面交:在二维几何平面上,给出若干个半平面,求它们的公共部分 半平面交的结果:1.凸多边形(后面会讲解到)2.无界,因为有可能若干半平面没有形成封闭3.直线,线段,点,空(属于特殊情况吧) 算法:1:根据上图可以知道,运用给出的多边形每相邻两点形成一条直线来切割原有多边形,如果多边形上的点i在有向直线的左边或者在直线上即保存起来,否则判断此点的前一个点i-1和后一个点i+1是否在此直线的左边或线上,在的话分别用点i和点i-1构成的直线与此时正在切割的直

UVa 1475 (二分+半平面交) Jungle Outpost

题意: 有n个瞭望塔构成一个凸n边形,敌人会炸毁一些瞭望台,剩下的瞭望台构成新的凸包.在凸多边形内部选择一个点作为总部,使得敌人需要炸毁的瞭望塔最多才能使总部暴露出来.输出敌人需要炸毁的数目. 分析: 在炸毁同样数量的瞭望塔时,如何爆破才能使暴露出的面积最大.那就是集中火力炸掉连续的几个瞭望塔.直觉上是这样的,我不会证明这个结论.因为是连续爆破,所以k次爆破后还保留的部分就是一个半平面,枚举这k个爆破点,如果这些半平面交非空则总部可以设在这里. k值是通过二分来确定的,下界是1,上界是n-3(这